
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Setting the Analogboard DAC Output Voltage
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function SetVoltage(fVoltage As Float) As Byte
Local Vsetm As Word		' The Master DAC Setting Return
Local Vsets As Word		' The Slave  DAC Setting Return
Local mbMSB As Byte
Local mbLSB As Byte	
Local sbMSB As Byte
Local sbLSB As Byte
' the VOut = Gain * (Vmaster * Rs + Vslave * Rm) / (Rm+Rs), Fullscale of the Vm = 5V and Vs = -5V, Gain = 2.5
fVtrn = fVoltage
fVtrn = fVtrn / fDACGain
fVset = fVtrn
'Get the MasteDAC Voltage Setting Value, Vm=[Vo*(Rm+Rs)+2.5*Rm]/Rs , at Default, the Slave DAC Output = -2.5V
fVtrn = (fVtrn * (fMResistance + fSResistance) + fDACenter * fMResistance) / fSResistance
fVtrn = fVtrn * 65535 / fDACReference							'The Master DAC(MAX541) is 16bit DAC, Fullscale = 2^16 = 65536
Vsetm = fVtrn
mbMSB = Msb(Vsetm)												'Split the Setting Word to two Byte, Get the MSB Byte
mbLSB = Vsetm - mbMSB * 256										'Split the Setting Word to two Byte, Get the LSB Byte
' Get the SlaveDAC Voltage Setting Value,Vs=[Vo*(Rm+Rs)-Vm*Rs]/Rm
fVtrn = Vsetm * fDACReference / 65535
fVtrn = 0 - ((fVset * (fMResistance + fSResistance) - fVtrn * fSResistance) / fMResistance)
fVtrn = fVtrn * 4096 / fDACReference							'The Slave DAC(MAX515) is 12bit DAC, Fullscale = 2^12 = 4096
Vsets = fVtrn
sbMSB = Msb(Vsets)												'Split the Setting Word to two Byte, Get the MSB Byte
sbLSB = Vsets - sbMSB * 256										'Split the Setting Word to two Byte, Get the LSB Byte
WriteDAC(mbMSB, mbLSB, sbMSB, sbLSB)
' Write the Setting to DAC
'Setp 1:
'bSregister = bSregister And &b00001111							'Hold the Analog Switch Status and Setting the DAC to Write Mode
'ShiftOut mbMSB;mbLSB;sbMSB;sbLSB;bSregister						'Write to Serial Bus
'WriteDAC(mbMSB) : WriteDAC(mbLSB) : WriteDAC(sbMSB) : WriteDAC(sbLSB) : WriteDAC(bSregister)
'IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Write
'Setp 2:
'bSregister = bSregister + &b10000000							'Hold the Analog Switch Status and Setting the DAC to Update
'ShiftOut mbMSB;mbLSB;sbMSB;sbLSB;bSregister
'WriteDAC(mbMSB) : WriteDAC(mbLSB) : WriteDAC(sbMSB) : WriteDAC(sbLSB) : WriteDAC(bSregister)
'IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Update
Return 0
End Function


'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Setting the Analog Switch(ADC Input Channel)
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function SetChannel(Channel As Byte) As Byte				
Local Channelset As Byte
Channelset = bSregister And &b11110000
WriteSReg(Channelset)		' Open all Analog Switch when Close Next Switch
WaitMs 10
bSregister = Channelset + Channel
WriteSReg(bSregister)
Return bSregister
End Function
'///////////////////////////////////////////////////////////////////////////////////////////////////



Function WriteDAC(bmDath As Byte, bmDatL As Byte, bsDath As Byte, bsDatL As Byte) As Byte
' Setp 1:
bSregister = bSregister And &b00001111							'Hold the Analog Switch Status and Setting the DAC to Write Mode
WriteSBUS(bmDath) : WriteSBUS(bmDatL) : WriteSBUS(bsDath) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Write
' Setp 2:
bSregister = bSregister + &b10000000							'Hold the Analog Switch Status and Setting the DAC to Update
WriteSBUS(bmDath) : WriteSBUS(bmDatL) : WriteSBUS(bsDath) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Update
Return 0
End Function